/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  mkdb.util.Counter
 *  mkio.Engine
 */
package fire.pb.statistics;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.atomic.AtomicLong;
import javax.management.MBeanAttributeInfo;
import javax.management.MBeanInfo;
import mkdb.util.Counter;
import mkio.Engine;

public class ProtocolStatistics {
    public static Counter countSend = new Counter(Engine.mbeans(), "xdb", "Sends.send");
    public static Counter countBroadcast = new Counter(Engine.mbeans(), "xdb", "BroadCasts.send");
    public static Counter countSendSize = new Counter(Engine.mbeans(), "xdb", "Sends.sendSize");
    public static Counter countRecv = new Counter(Engine.mbeans(), "xdb", "Sends.recv");
    public static Counter countRecvSize = new Counter(Engine.mbeans(), "xdb", "Sends.recvSize");
    public static Map<String, StatisticAttr> sendprotocols = new HashMap<String, StatisticAttr>();
    public static Map<String, StatisticAttr> recvprotocols = new HashMap<String, StatisticAttr>();

    public static void process() {
        ProtocolStatistics.processSends();
        ProtocolStatistics.processRecvs();
    }

    private static void processSends() {
        MBeanInfo info = countSendSize.getMBeanInfo();
        for (MBeanAttributeInfo attrinfo : info.getAttributes()) {
            String classname = attrinfo.getName();
            StatisticAttr statis = sendprotocols.get(classname);
            if (statis == null) {
                statis = new StatisticAttr(classname);
                sendprotocols.put(classname, statis);
            }
            int newnum = 0;
            AtomicLong atomicnum = countSend.get(classname);
            if (atomicnum == null) {
                atomicnum = countBroadcast.get(classname);
            }
            if (atomicnum != null) {
                newnum = (int)atomicnum.get();
            }
            long newsize = 0L;
            AtomicLong atomicsize = countSendSize.get(classname);
            if (atomicsize != null) {
                newsize = atomicsize.get();
            }
            statis.lastperiod_num = newnum - statis.totalnum;
            statis.lastperiod_size = newsize - statis.totalsize;
            statis.lastperiod_avgsize = (int)statis.lastperiod_size / statis.lastperiod_num;
            statis.totalnum = newnum;
            statis.totalsize = newsize;
            statis.avgsize = (int)newsize / newnum;
        }
    }

    private static void processRecvs() {
        MBeanInfo info = countRecv.getMBeanInfo();
        for (MBeanAttributeInfo attrinfo : info.getAttributes()) {
            String classname = attrinfo.getName();
            StatisticAttr statis = recvprotocols.get(classname);
            if (statis == null) {
                statis = new StatisticAttr(classname);
                recvprotocols.put(classname, statis);
            }
            int newnum = 0;
            AtomicLong atomicnum = countRecv.get(classname);
            if (atomicnum != null) {
                newnum = (int)atomicnum.get();
            }
            long newsize = 0L;
            AtomicLong atomicsize = countRecvSize.get(classname);
            if (atomicsize != null) {
                newsize = atomicsize.get();
            }
            statis.lastperiod_num = newnum - statis.totalnum;
            statis.lastperiod_size = newsize - statis.totalsize;
            statis.lastperiod_avgsize = (int)statis.lastperiod_size / statis.lastperiod_num;
            statis.totalnum = newnum;
            statis.totalsize = newsize;
            statis.avgsize = (int)newsize / newnum;
        }
    }

    public static class StatisticAttr {
        public final String classname;
        public int totalnum;
        public long totalsize;
        public int avgsize;
        public int lastperiod_num;
        public long lastperiod_size;
        public int lastperiod_avgsize;

        public StatisticAttr(String classname) {
            this.classname = classname;
        }
    }
}

